// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package hn

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// HnServiceClient is the client API for HnService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type HnServiceClient interface {
	GetTopStories(ctx context.Context, in *TopStoriesRequest, opts ...grpc.CallOption) (HnService_GetTopStoriesClient, error)
	Whois(ctx context.Context, in *WhoisRequest, opts ...grpc.CallOption) (*User, error)
}

type hnServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewHnServiceClient(cc grpc.ClientConnInterface) HnServiceClient {
	return &hnServiceClient{cc}
}

func (c *hnServiceClient) GetTopStories(ctx context.Context, in *TopStoriesRequest, opts ...grpc.CallOption) (HnService_GetTopStoriesClient, error) {
	stream, err := c.cc.NewStream(ctx, &HnService_ServiceDesc.Streams[0], "/hn.HnService/GetTopStories", opts...)
	if err != nil {
		return nil, err
	}
	x := &hnServiceGetTopStoriesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type HnService_GetTopStoriesClient interface {
	Recv() (*Story, error)
	grpc.ClientStream
}

type hnServiceGetTopStoriesClient struct {
	grpc.ClientStream
}

func (x *hnServiceGetTopStoriesClient) Recv() (*Story, error) {
	m := new(Story)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *hnServiceClient) Whois(ctx context.Context, in *WhoisRequest, opts ...grpc.CallOption) (*User, error) {
	out := new(User)
	err := c.cc.Invoke(ctx, "/hn.HnService/Whois", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// HnServiceServer is the server API for HnService service.
// All implementations must embed UnimplementedHnServiceServer
// for forward compatibility
type HnServiceServer interface {
	GetTopStories(*TopStoriesRequest, HnService_GetTopStoriesServer) error
	Whois(context.Context, *WhoisRequest) (*User, error)
	mustEmbedUnimplementedHnServiceServer()
}

// UnimplementedHnServiceServer must be embedded to have forward compatible implementations.
type UnimplementedHnServiceServer struct {
}

func (UnimplementedHnServiceServer) GetTopStories(*TopStoriesRequest, HnService_GetTopStoriesServer) error {
	return status.Errorf(codes.Unimplemented, "method GetTopStories not implemented")
}
func (UnimplementedHnServiceServer) Whois(context.Context, *WhoisRequest) (*User, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Whois not implemented")
}
func (UnimplementedHnServiceServer) mustEmbedUnimplementedHnServiceServer() {}

// UnsafeHnServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to HnServiceServer will
// result in compilation errors.
type UnsafeHnServiceServer interface {
	mustEmbedUnimplementedHnServiceServer()
}

func RegisterHnServiceServer(s grpc.ServiceRegistrar, srv HnServiceServer) {
	s.RegisterService(&HnService_ServiceDesc, srv)
}

func _HnService_GetTopStories_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(TopStoriesRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(HnServiceServer).GetTopStories(m, &hnServiceGetTopStoriesServer{stream})
}

type HnService_GetTopStoriesServer interface {
	Send(*Story) error
	grpc.ServerStream
}

type hnServiceGetTopStoriesServer struct {
	grpc.ServerStream
}

func (x *hnServiceGetTopStoriesServer) Send(m *Story) error {
	return x.ServerStream.SendMsg(m)
}

func _HnService_Whois_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(WhoisRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(HnServiceServer).Whois(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/hn.HnService/Whois",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(HnServiceServer).Whois(ctx, req.(*WhoisRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// HnService_ServiceDesc is the grpc.ServiceDesc for HnService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var HnService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "hn.HnService",
	HandlerType: (*HnServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Whois",
			Handler:    _HnService_Whois_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetTopStories",
			Handler:       _HnService_GetTopStories_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "news.proto",
}
